// ScrambleCtl.cpp : Implementation of the CScrambleCtrl ActiveX Control class.

#include "stdafx.h"
#include "Scramble.h"
#include "ScrambleCtl.h"
#include "ScramblePpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CScrambleCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CScrambleCtrl, COleControl)
	//{{AFX_MSG_MAP(CScrambleCtrl)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
	ON_BN_CLICKED(IDC_BUTTON, OnButtonClicked)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CScrambleCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CScrambleCtrl)
	DISP_PROPERTY_EX(CScrambleCtrl, "ScrambleString", GetScrambleString, SetScrambleString, VT_BSTR)
	DISP_PROPERTY_EX(CScrambleCtrl, "AnswerString", GetAnswerString, SetAnswerString, VT_BSTR)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CScrambleCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CScrambleCtrl, COleControl)
	//{{AFX_EVENT_MAP(CScrambleCtrl)
	// NOTE - ClassWizard will add and remove event map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CScrambleCtrl, 1)
	PROPPAGEID(CScramblePropPage::guid)
END_PROPPAGEIDS(CScrambleCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CScrambleCtrl, "SCRAMBLE.ScrambleCtrl.1",
	0x3206dca8, 0x6ca1, 0x11d1, 0xab, 0x9f, 0x50, 0xc1, 0x53, 0xc1, 0, 0)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CScrambleCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DScramble =
		{ 0x3206dca6, 0x6ca1, 0x11d1, { 0xab, 0x9f, 0x50, 0xc1, 0x53, 0xc1, 0, 0 } };
const IID BASED_CODE IID_DScrambleEvents =
		{ 0x3206dca7, 0x6ca1, 0x11d1, { 0xab, 0x9f, 0x50, 0xc1, 0x53, 0xc1, 0, 0 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwScrambleOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CScrambleCtrl, IDS_SCRAMBLE, _dwScrambleOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CScrambleCtrl::CScrambleCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CScrambleCtrl

BOOL CScrambleCtrl::CScrambleCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_SCRAMBLE,
			IDB_SCRAMBLE,
			afxRegApartmentThreading,
			_dwScrambleOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CScrambleCtrl::CScrambleCtrl - Constructor

CScrambleCtrl::CScrambleCtrl()
{
	InitializeIIDs(&IID_DScramble, &IID_DScrambleEvents);

	// TODO: Initialize your control's instance data here.

	m_scrambleStr = "ERSBCMLA";
	m_answerStr = "SCRAMBLE";
}


/////////////////////////////////////////////////////////////////////////////
// CScrambleCtrl::~CScrambleCtrl - Destructor

CScrambleCtrl::~CScrambleCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CScrambleCtrl::OnDraw - Drawing function

void CScrambleCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));

	pdc->TextOut(20, 50, "Enter Answer:");

    LOGFONT logFont;
    logFont.lfHeight = 32;
    logFont.lfWidth = 0;
    logFont.lfEscapement = 0;
    logFont.lfOrientation = 0;
    logFont.lfWeight = FW_BOLD;
    logFont.lfItalic = 0;
    logFont.lfUnderline = 0;
    logFont.lfStrikeOut = 0;
    logFont.lfCharSet = ANSI_CHARSET;
    logFont.lfOutPrecision = OUT_DEFAULT_PRECIS;
    logFont.lfClipPrecision = CLIP_DEFAULT_PRECIS;
    logFont.lfQuality = PROOF_QUALITY;
    logFont.lfPitchAndFamily = VARIABLE_PITCH | FF_ROMAN;
    strcpy(logFont.lfFaceName, "Times New Roman");

    CFont font;
    font.CreateFontIndirect(&logFont);
	CFont* pOldFont = pdc->SelectObject(&font);
	pdc->TextOut(20, 10, m_scrambleStr);
	pdc->SelectObject(pOldFont);
}


/////////////////////////////////////////////////////////////////////////////
// CScrambleCtrl::DoPropExchange - Persistence support

void CScrambleCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CScrambleCtrl::OnResetState - Reset control to default state

void CScrambleCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CScrambleCtrl::AboutBox - Display an "About" box to the user

void CScrambleCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_SCRAMBLE);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CScrambleCtrl message handlers

int CScrambleCtrl::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (COleControl::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	m_edit.Create(WS_CHILD | WS_BORDER | WS_VISIBLE |
		ES_AUTOHSCROLL, CRect(20, 70, 120, 100),
		this, IDC_EDIT);
	m_button.Create("Submit", WS_CHILD | WS_BORDER |
		WS_VISIBLE | BS_PUSHBUTTON,
		CRect(130, 70, 230, 100), this, IDC_BUTTON);

	return 0;
}

BSTR CScrambleCtrl::GetScrambleString() 
{
	CString strResult;
	// TODO: Add your property handler here

	strResult = m_scrambleStr;

	return strResult.AllocSysString();
}

void CScrambleCtrl::SetScrambleString(LPCTSTR lpszNewValue) 
{
	// TODO: Add your property handler here

	m_scrambleStr = lpszNewValue;
	InvalidateControl();

	SetModifiedFlag();
}

BSTR CScrambleCtrl::GetAnswerString() 
{
	CString strResult;
	// TODO: Add your property handler here

	strResult = m_answerStr;

	return strResult.AllocSysString();
}

void CScrambleCtrl::SetAnswerString(LPCTSTR lpszNewValue) 
{
	// TODO: Add your property handler here

	m_answerStr = lpszNewValue;
	InvalidateControl();

	SetModifiedFlag();
}

void CScrambleCtrl::OnButtonClicked()
{
	CString str;
	m_edit.GetWindowText(str);
	str.MakeUpper();

	if (str == m_answerStr)
		m_edit.SetWindowText("Correct!");
	else
		m_edit.SetWindowText("Incorrect");
}
